#include <math.h>

unsigned int fpu_atof(char *str){ /* not implemented */
	float f;
	f = (float)atof(str);
	return *((unsigned int *)(&f));
}

void print_float(unsigned int f){ /* not implemented */
	printf("%f", *((float *)(&f)));
}

unsigned int fpu_fadd(unsigned int in1, unsigned int in2){
	float r = ((*((float*)&in1)) + (*((float*)&in2)));
	return *((unsigned int*)&r);
}

unsigned int fpu_fsub(unsigned int in1, unsigned int in2){
	float r = ((*((float*)&in1)) - (*((float*)&in2)));
	return *((unsigned int*)&r);
}

unsigned int fpu_fmul(unsigned int in1, unsigned int in2){
	float r = ((*((float*)&in1)) * (*((float*)&in2)));
	return *((unsigned int*)&r);
}

unsigned int fpu_finvsqrt(unsigned int in1){
	float r = (float)(1.0 / sqrt(*((float*)&in1)));
	return *((unsigned int*)&r);
}

unsigned int fpu_itof(unsigned int in1){
	float r = (float)((int)in1);
	return *((unsigned int*)(&r));
}

unsigned int fpu_ftoi(unsigned int in1){
	float f = *((float*)&in1);
	if(f < 0)
		return (unsigned int)((int)(f - 0.5));
	return (unsigned int)((int)(f + 0.5));
}

unsigned int fpu_fless(unsigned int in1, unsigned int in2){
	if((*((float*)&in1)) < (*((float*)&in2)))
		return 0xffffffffU;
	return 0;
}

unsigned int fpu_fneg(unsigned int op1){
	return fpu_fsub(0x00000000U, op1);
}

unsigned int fpu_fiszero(unsigned int op1){
	if(!(op1 & 0x7f800000U))
		return 0xffffffffU;
	return 0x00000000U;
}

unsigned int fpu_fispos(unsigned int op1){
	return fpu_fless(0x00000000U, op1);
}

unsigned int fpu_fisneg(unsigned int op1){
	return fpu_fless(op1, 0x80000000U);
}

unsigned int fpu_fabs(unsigned int op1){
	return (op1 & 0x7fffffffU);
}

unsigned int fpu_fhalf(unsigned int op1){
	return fpu_fmul(op1, 0x3f000000U);
}

unsigned int fpu_fsqr(unsigned int op1){
	return fpu_fmul(op1, op1);
}

unsigned int fpu_finv(unsigned int op1){
	return ((fpu_finvsqrt(fpu_fmul(op1, op1))) ^ (op1 & 0x80000000U));
}

unsigned int fpu_fsqrt(unsigned int op1){
	return fpu_finv(fpu_finvsqrt(op1));
}

unsigned int fpu_fdiv(unsigned int op1, unsigned int op2){
	return fpu_fmul(op1, fpu_finv(op2));
}
